KUBERNETES(1)(kubernetes)

Eric Paris Jan 2015

NAME

kubectl proxy - Run a proxy to the Kubernetes API server

SYNOPSIS

kubectl proxy [OPTIONS]

DESCRIPTION

Creates a proxy server or application-level gateway between localhost and the Kubernetes API server. It also allows serving static content over specified HTTP path. All incoming data enters through one port and gets forwarded to the remote Kubernetes API server port, except for the path matching the static content path.

OPTIONS

--accept-hosts="^localhost$,^127\.0\.0\.1$,^\[::1\]$"
    Regular expression for hosts that the proxy should accept.

--accept-paths="^.*"
    Regular expression for paths that the proxy should accept.

--address="127.0.0.1"
    The IP address on which to serve on.

--api-prefix="/"
    Prefix to serve the proxied API under.

--append-server-path=false
    If true, enables automatic path appending of the kube context server path to each request.

--disable-filter=false
    If true, disable request filtering in the proxy. This is dangerous, and can leave you vulnerable to XSRF attacks, when used with an accessible port.

--keepalive=0s
    keepalive specifies the keep-alive period for an active network connection. Set to 0 to disable keepalive.

-p, --port=8001
    The port on which to run the proxy. Set to 0 to pick a random port.

--reject-methods="^$"
    Regular expression for HTTP methods that the proxy should reject (example --reject-methods='POST,PUT,PATCH').

--reject-paths="^/api/./pods/./exec,^/api/./pods/./attach"
    Regular expression for paths that the proxy should reject. Paths specified here will be rejected even accepted by --accept-paths.

-u, --unix-socket=""
    Unix socket on which to run the proxy.

-w, --www=""
    Also serve static files from the given directory under the specified prefix.

-P, --www-prefix="/static/"
    Prefix to serve static files under, if static file directory is specified.

OPTIONS INHERITED FROM PARENT COMMANDS

--as=""
    Username to impersonate for the operation. User could be a regular user or a service account in a namespace.

--as-group=[]
    Group to impersonate for the operation, this flag can be repeated to specify multiple groups.

--as-uid=""
    UID to impersonate for the operation.

--cache-dir="/home/username/.kube/cache"
    Default cache directory

--certificate-authority=""
    Path to a cert file for the certificate authority

--client-certificate=""
    Path to a client certificate file for TLS

--client-key=""
    Path to a client key file for TLS

--cluster=""
    The name of the kubeconfig cluster to use

--context=""
    The name of the kubeconfig context to use

--disable-compression=false
    If true, opt-out of response compression for all requests to the server

--insecure-skip-tls-verify=false
    If true, the server's certificate will not be checked for validity. This will make your HTTPS connections insecure

--kubeconfig=""
    Path to the kubeconfig file to use for CLI requests.

--match-server-version=false
    Require server version to match client version

-n, --namespace=""
    If present, the namespace scope for this CLI request

--password=""
    Password for basic authentication to the API server

--profile="none"
    Name of profile to capture. One of (none|cpu|heap|goroutine|threadcreate|block|mutex)

--profile-output="profile.pprof"
    Name of the file to write the profile to

--request-timeout="0"
    The length of time to wait before giving up on a single server request. Non-zero values should contain a corresponding time unit (e.g. 1s, 2m, 3h). A value of zero means don't timeout requests.

-s, --server=""
    The address and port of the Kubernetes API server

--tls-server-name=""
    Server name to use for server certificate validation. If it is not provided, the hostname used to contact the server is used

--token=""
    Bearer token for authentication to the API server

--user=""
    The name of the kubeconfig user to use

--username=""
    Username for basic authentication to the API server

--version=false
    --version, --version=raw prints version information and quits; --version=vX.Y.Z... sets the reported version

--warnings-as-errors=false
    Treat warnings received from the server as errors and exit with a non-zero exit code

EXAMPLE
      # To proxy all of the Kubernetes API and nothing else
      kubectl proxy --api-prefix=/

      # To proxy only part of the Kubernetes API and also some static files
      # You can get pods info with 'curl localhost:8001/api/v1/pods'
      kubectl proxy --www=/my/files --www-prefix=/static/ --api-prefix=/api/

      # To proxy the entire Kubernetes API at a different root
      # You can get pods info with 'curl localhost:8001/custom/api/v1/pods'
      kubectl proxy --api-prefix=/custom/

      # Run a proxy to the Kubernetes API server on port 8011, serving static content from ./local/www/
      kubectl proxy --port=8011 --www=./local/www/

      # Run a proxy to the Kubernetes API server on an arbitrary local port
      # The chosen port for the server will be output to stdout
      kubectl proxy --port=0

      # Run a proxy to the Kubernetes API server, changing the API prefix to k8s-api
      # This makes e.g. the pods API available at localhost:8001/k8s-api/v1/pods/
      kubectl proxy --api-prefix=/k8s-api

SEE ALSO

kubectl(1),

HISTORY

January 2015, Originally compiled by Eric Paris (eparis at redhat dot com) based on the kubernetes source material, but hopefully they have been automatically generated since!